#!/usr/bin/perl

use strict;
use File::Find;

$File::Find::prune = "true";

if($ARGV[0] eq "help" || $ARGV[0] eq "?" || $ARGV[0] eq ""){
	print "Utility to fix errors in stm2scala's output. Horrid hax 'R' us.\n\n";
	print "Execute \"masher.pl <filenames>\" to convert named files\n";
	print "Execute \"masher.pl -all\" to convert all .par files in directory\n";
}
elsif($ARGV[0] eq "-all"){	
	find(\&wanted,".");
}
else{
	foreach my $infile (@ARGV){
		mangle($infile);
	}
}

sub mangle ($) {
	my $infile = @_[0];
	open (INFILE, $infile) || die("Couldn\'t find that file. Sorry\n");
	open (OUTFILE, ">".$infile.".fixed.par") || die("Couldn\'t open file for output. Yikes!\n");	
	binmode(INFILE);
	binmode(OUTFILE);
		
	
	while(<INFILE>){
		$_ =~ s/Image size in X/Image Size in X/;
		$_ =~ s/Image size in Y/Image Size in Y/;
		$_ =~ s/Measurment parameters/Measurement parameters./;
		$_ =~ s/Automatic Z Zero/Automatic Z zero/;
		print OUTFILE $_;
	}	
	print "Mangled $infile\n";
	return 0;
}

sub wanted {
	if($_=~m/\.par$/){
		mangle($_);
	}
}